import java.awt.event.*;
import java.util.*;
import java.awt.*;
import java.net.*;
import java.io.*;
public class ClientGUI2 extends Frame {
  int ROWS=15,COLS=65;
  int X=500,Y=500;
  static final int BUT_SIZE= 50;
  static final int UP_BORDER= 50;
  static final int DOWN_BORDER= 60;
  static final int LEFT_BORDER= 20;
  static final int GAP=20;
  static final int HTTP_STANDARD_PORT =8080;	
  static final String CACHE_DIRECTORY="cache";
  static final String WORKING_DIRECTORY="."+File.separator;
  static final String CFG_FILE="gfg.cfg";
  static final int BYTES_PER_ROW=4;
  static final int CACHE_SIZE=4;
  static final String URL_EXTENSION=".url";
  
  byte[] buf=new byte[BYTES_PER_ROW];
  int cache_first;//sui file
  int cache_last;//sui file, prox da scrivere
  int cache_cur;//sullo schermo, cur rispetto a first
  //  TextArea bigtext=new TextArea(ROWS,COLS);
  
  
  
  Button backbut=new Button("Back"),
    fwdbut = new Button("Forward"),
    reloadbut=new Button("Reload"), //attenzione il nome  usato altrove
    sendbut=new Button("Send"),
    closebut=new Button("Close"),
    
    listbut=new Button("List");
  
  
  CheckboxGroup cbg = new CheckboxGroup();
  Checkbox tcp = new Checkbox("TCP", cbg, true);
  Checkbox udp = new Checkbox("UDP", cbg, false);
  
  Label urllab=new Label("Location");
  
  TextArea actiontext=new TextArea(ROWS,COLS);
  
  TextField urltext=new TextField(COLS-10);
  
  
  //**************MENU ZONE
  
  MenuBar mb1 = new MenuBar();
  Menu f = new Menu("File");
   
  MenuItem[] file = {
    
    new MenuItem("Open"),
    new MenuItem("Save"),
    
    new MenuItem("Exit", 
      new MenuShortcut(KeyEvent.VK_E))
  };
  Menu o=new Menu("Options");
MenuItem[] options={
  new MenuItem("Clear cache")
};
  
  // Initialization code:
  {
    ML ml=new ML();
    CCL ccl=new CCL();
    file[0].setActionCommand("Open");
    file[0].addActionListener(ml);
    file[1].setActionCommand("Save");
    file[1].addActionListener(ml);
    file[2].setActionCommand("Exit");
    file[2].addActionListener(ml);
 options[0].setActionCommand("ClearCache");
 options[0].addActionListener(ccl);
 
  }
  class CCL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      MenuItem target = (MenuItem)e.getSource();
      String actionCommand = 
        target.getActionCommand();
      if(actionCommand.equals("ClearCache")) {
	File ff;
	System.out.println("Clearing!!");
	for (int i=0;i<CACHE_SIZE;i++){
	  ff=new File(WORKING_DIRECTORY+CACHE_DIRECTORY,(new Integer(i)).toString());
	  ff.delete();
	  ff=new File(WORKING_DIRECTORY+CACHE_DIRECTORY,(new Integer(i)).toString()+URL_EXTENSION);
	  ff.delete();
	  
	}//for
	cache_first=0;
	cache_last=0;
	cache_cur=0;
      }//if
    }//performed
  }//CCL
  class ML implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      MenuItem target = (MenuItem)e.getSource();
      String actionCommand = 
        target.getActionCommand();
      if(actionCommand.equals("Open")) {
	FileDialog d = new FileDialog(
				      ClientGUI2.this,
				      "Apri file");
	d.setFile("*.*");
	d.setDirectory("."); // Current directory
	d.show();
	String yourFile = "*.*";
	if((yourFile = d.getFile()) != null) {
	  
	  
	  try {
	    
	    File cf=new File(d.getDirectory(),yourFile);
	    FileInputStream fis = new FileInputStream(cf);
	    byte[] tmpbuf=new byte[(new Long(cf.length())).intValue()];//***********************************************************************************
	    
	    int lg=fis.read(tmpbuf);
	    System.out.println("\n read "+lg+" bytes: "+tmpbuf+"\n");
	    System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
	    String temp=(new String(tmpbuf,0,lg));
	    
	    System.out.println("temp= <"+temp+">");  
	    
	    actiontext.setText(temp);
	    fis.close();
	  } catch (Exception er){actiontext.setText(er.toString());}
	  
	  
	  
	  
	  
	  
	  
	  
	} else {
	  actiontext.setText("You pressed cancel");
	  
	}
      } //else
      else if (actionCommand.equals("Save")) {
	FileDialog d = new FileDialog(
				      ClientGUI2.this,
				      "Salva file");
	d.setFile("*.java");
	d.setDirectory("."); // Current directory
	d.show();
	String yourFile = "*.*";
	if((yourFile = d.getFile()) != null) {
	  
	  saveOnFile(actiontext.getText(),d.getDirectory(),yourFile);
	} else {
	  actiontext.setText("Operazione annullata");
	  
	}
      }//else
      
      else if(actionCommand.equals("Exit")) {
        dispatchEvent(
		      new WindowEvent(ClientGUI2.this, 
				      WindowEvent.WINDOW_CLOSING));
      }
    }
  }
  //************************
  
  
  
  
  
  
  public int close_client()
  {
    try {  //salva dati
      File f= (new File(WORKING_DIRECTORY,CFG_FILE));
      if (f.exists()) {  System.out.println("\n Already present.Overwrite!"); f.delete();}
      //    System.out.println("new_ab: file exists "+f.exists()+" name "+f.getName());  //messaggio 
      FileOutputStream fos=new FileOutputStream(f);
      buf=(fill(cache_first+"\r\n")).getBytes();
      fos.write(buf,0,BYTES_PER_ROW);
      buf=(fill(cache_last+"\r\n")).getBytes();
      fos.write(buf,0,BYTES_PER_ROW);
      
      fos.close();
      System.out.println("new_ab: file exists "+f.exists()+" name "+f.getName());  //messaggio 
      
      return 0; 
    }catch(Exception ek){System.out.println("ecc "+ek);return 1;}
    
    
  }
  
  String fill(String s)
  {
    int temp=s.length();
    if (temp>BYTES_PER_ROW) return s.substring(0,BYTES_PER_ROW);//sdfsdf
    if (temp==BYTES_PER_ROW) return s;
    temp=BYTES_PER_ROW-temp; //>0
    String res=s;
    for (int i=0;i<temp;i++) res+=" ";
    System.out.println("fill: res='"+res+"' lg="+res.length());
    return  res;
  }
  
  int saveOnFile(String tosave,String dir,String name)
  {
    System.out.println("tosave= <<<"+tosave+">>>");
    try {  
      File file= (new File(dir,name));
      byte[] buf=new byte[tosave.length()];
      System.out.println("creacc: file exists "+file.exists()+" name "+file.getName());  //messaggio 
      FileOutputStream fos=new FileOutputStream(file);
      buf=(tosave).getBytes();
      fos.write(buf);
      fos.close();
      
    }catch(Exception eee){System.out.println("errore sul file"); return -1;}
    
    return 0;
  }
  
  
  String readFromFile(String dir,String filename)
  {
    
    try {
      
      File cf=new File(dir,filename);
      FileInputStream fis = new FileInputStream(cf);
      byte[] tmpbuf=new byte[(new Long(cf.length())).intValue()];//***********************************************************************************
      
      int lg=fis.read(tmpbuf);
      System.out.println("\n read "+lg+" bytes: "+tmpbuf+"\n");
      System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
      String temp=(new String(tmpbuf,0,lg));
      
      System.out.println("temp= <"+temp+">");  
      fis.close();
      return temp;
    } catch (Exception er){System.out.println(er); return "";}
  }
  
  //*************COSTRUTTORE
  
  ClientGUI2(String args[]) {
    
    //******menu
    for(int i = 0; i < file.length; i++)
      f.add(file[i]);
    for(int i = 0; i < options.length; i++)
      o.add(options[i]);
    mb1.add(f);
    mb1.add(o);
    setMenuBar(mb1);
    
    //******menu ends
    
    
    
    
    
    /*******************************
      lettura dei parametri di configurazione
      ********************************/
      
      
      try{  

	
	File cf=new File(WORKING_DIRECTORY+"cache");
	if (!cf.exists()) {cf.mkdirs();} 
	
	
	cf=new File(WORKING_DIRECTORY,CFG_FILE);
	FileInputStream fis = new FileInputStream(cf);
	int lg=fis.read(buf);
	System.out.println("\n read "+lg+" bytes: "+buf+"\n");
	System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
	//System.out.println(" read "+lg+" bytes: "+buf+" ct="+counter+" buflg="+buf.length);             
	String temp=(new String(buf,0,lg));
	//temp=fill(temp);
	System.out.println("temp= <"+temp+">");  
	
	Integer l=new Integer(temp.trim());
               System.out.println("\n cache_first = "+l+"\n");
               cache_first=l.intValue();
	       cache_cur=0;//******************
	       System.out.println("\ncache_first="+cache_first+"\ncache_cur="+cache_cur+" cache_last="+cache_last);
	       lg=fis.read(buf);
               System.out.println("\n read "+lg+" bytes: "+buf+"\n");
               System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
	       //System.out.println(" read "+lg+" bytes: "+buf+" ct="+counter+" buflg="+buf.length);             
	       temp=(new String(buf,0,lg));
               fis.close();
	       l=new Integer(temp.trim());
               System.out.println("\n cache_last = "+l+"\n");
               cache_last=l.intValue();   
	       cache_cur=0;
	       System.out.println("\ncache_cur="+cache_cur+"\ncache_first="+cache_first+" cache_last="+cache_last);
	       
	       
      }
      catch(Exception ec)
	{
	  System.out.println(ec); 
	  cache_first=0;cache_last=0;/***********************************/
	       System.out.println("\ncache_cur="+cache_cur+"\ncache_first="+cache_first+" cache_last="+cache_last);
	       
	}
      
      
      

      

      

      setLayout(new FlowLayout());

      //tcp.addItemListener(new tcpL());
      //udp.addItemListener(new udpL());
      //savebut.addActionListener(new savebutL());
      //loadbut.addActionListener(new loadbutL());
      
      backbut.addActionListener(new backbutL());
      fwdbut.addActionListener(new fwdbutL());
      reloadbut.addActionListener(new sendbutL());
      closebut.addActionListener(new closebutL());
      sendbut.addActionListener(new sendbutL());
      listbut.addActionListener(new listbutL());
      add(backbut);
      add(fwdbut);
      add(reloadbut);
      add(urllab);
      add(closebut);
      add(listbut);
      add(sendbut);
      add(udp);
      add(tcp);
      add(actiontext);
      add(urltext);
      setForeground(Color.black);
      // setLayout(new GridLayout(2, 1));
      
      
  }
  
  
  String incache(String url)
  {
    for (int i=0;i<CACHE_SIZE;i++){
      String url2=readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,(new Integer(i)).toString()+URL_EXTENSION);
      if (url.compareTo(url2)==0) return readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,(new Integer(i)).toString()+URL_EXTENSION);
      
      
      
    }
return "";
  }
  
  
  public void adjust()
  {
    
    setSize(X,Y);
    setResizable(false);
    setBackground(Color.lightGray);
    setVisible(true);
    
    listbut.setLocation(LEFT_BORDER+3*BUT_SIZE+3*GAP,UP_BORDER);
    listbut.setSize(BUT_SIZE,BUT_SIZE);
    backbut.setLocation(LEFT_BORDER,UP_BORDER);
    backbut.setSize(BUT_SIZE,BUT_SIZE);
    fwdbut.setLocation(LEFT_BORDER+BUT_SIZE+GAP,UP_BORDER);
    fwdbut.setSize(BUT_SIZE,BUT_SIZE);
    reloadbut.setLocation(2*BUT_SIZE+2*GAP+LEFT_BORDER,UP_BORDER);
    reloadbut.setSize(BUT_SIZE,BUT_SIZE);
    closebut.setLocation(X/3*2, Y-DOWN_BORDER);
    closebut.setSize(BUT_SIZE,BUT_SIZE);
    sendbut.setSize(BUT_SIZE,BUT_SIZE);
    sendbut.setLocation(X/3,Y- DOWN_BORDER);
    actiontext.setLocation(LEFT_BORDER,Y/3);
    urltext.setLocation(LEFT_BORDER+3*GAP,Y/3-2*GAP); 
    
    urllab.setLocation(LEFT_BORDER,Y/3-2*GAP);
    //tcp.setSize(30,30);
    //udp.setSize(30,30);
    tcp.setLocation(2*X/3,UP_BORDER+GAP);
    udp.setLocation(2*X/3+60,UP_BORDER+GAP);
    
  }
  
  
  public class listbutL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      actiontext.setText("");
      for (int i=0;i<CACHE_SIZE;i++){
	
	actiontext.setText(actiontext.getText()+"\n"+readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,(new Integer(i)).toString()+URL_EXTENSION));
	
      }//for
    }//perform
  }//listener
  
  
  
  
  public class fwdbutL implements ActionListener {
    
    public void actionPerformed(ActionEvent e) {
      System.out.println("\ncache_cur="+cache_cur+"\ncache_first="+cache_first+" cache_last="+cache_last);
      int i=(cache_cur+1)%CACHE_SIZE;
      
      if (i<0) {cache_cur=0;i=0;}
      if (i==cache_last) {System.out.println("\nEND OF CACHE");}
      else {
	cache_cur=i;
	Integer I=new Integer(i);
	
	//if (cache_first<=cache_last&&i<cache_last&&i>=cache_first||cache_first<=cache_last&&i<cache_last&&i>=cache_first)
	{
	  
	  actiontext.setText(readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,I.toString()));    
	  urltext.setText(readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,i+URL_EXTENSION));   
	}
	System.out.println("\ncache_cur="+cache_cur+"\ncache_first="+cache_first+" cache_last="+cache_last);
      }
    }

  }
  
  
  public class backbutL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      System.out.println("\ncache_cur="+cache_cur+"\ncache_first="+cache_first+" cache_last="+cache_last);
      
      
      
      
      /*********************************/
      int i=(cache_cur-1)%CACHE_SIZE;
      if (i<0) {cache_cur=0;i=0;}
if (cache_first==((cache_last-1)%CACHE_SIZE))//1 elemento in cache
  {
    Integer I=new Integer(i);
    
    
    System.out.println("\ncache_cur="+cache_cur+"\ncache_first="+cache_first+" cache_last="+cache_last);
    
    actiontext.setText(readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,I.toString()));    
    urltext.setText(readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,i+URL_EXTENSION));   
    
  }
else
  if (i<cache_first) {System.out.println("\nBEGINNING OF CACHE");}
  else{
    cache_cur=i;
    //if (i>=cache_first&&i<cache_last)
    
    Integer I=new Integer(i);
    
    
    System.out.println("\ncache_cur="+cache_cur+"\ncache_first="+cache_first+" cache_last="+cache_last);
    
    actiontext.setText(readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,I.toString()));    
    urltext.setText(readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,i+URL_EXTENSION));   
    
  }

    }
  }
  
  public class sendbutL implements ActionListener 
  {
    
    
    public class okL implements ActionListener 
    {
      public void actionPerformed(ActionEvent e) {
	int i;
	i=u.getPort();
	if (i==-1) i=HTTP_STANDARD_PORT;
	String temp="";
	try {
	  
	  temp=TcpClient2.Send(u.getHost(),u.getFile(),i,"get");
	}
	catch (Exception ee) {System.out.println(ee);
	actiontext.setText("errore nella risorsa");}
	
	//	 actiontext.setText(temp.substring(temp.lastIndexOf("\r\n\r\n")+4));
	
	ok.removeActionListener(okl);
	no.removeActionListener(nol);
	f.remove(ok);f.remove(no);f.remove(nlab);
	f.dispose();
      }
      
    }
    public class noL implements ActionListener 
    {
      public void actionPerformed(ActionEvent e) {
	ok.removeActionListener(okl);
	no.removeActionListener(nol);
	f.remove(ok);f.remove(no);f.remove(nlab);
	f.dispose();				}
      
    }
    public class salvaL implements ActionListener 
    {
      public void actionPerformed(ActionEvent e) {
	
	  try {  
            File file= (new File(".",testo.getText()));
	    byte[] buf=new byte[received_message.length()];
	    System.out.println("creacc: file exists "+file.exists()+" name "+file.getName());  //messaggio 
	    FileOutputStream fos=new FileOutputStream(file);
	    buf=(received_message).getBytes();
	    fos.write(buf);
	    fos.close();
	    
	  }catch(Exception eee){actiontext.setText("errore sul file");}
             
	  
	  apri.removeActionListener(april);
	  salva.removeActionListener(salval);
	  annulla.removeActionListener(annullal);
	  f.remove(notext);
	  f.remove(testo);    
	  f.remove(salva);
	  f.remove(apri);
	  f.remove(annulla);         
	  f.dispose();				}
      
    }
    public class apriL implements ActionListener 
    {
      public void actionPerformed(ActionEvent e) {
	FileDialog fd=new FileDialog(f);
	String choice=fd.getFile();
	apri.removeActionListener(april);
	salva.removeActionListener(salval);
	annulla.removeActionListener(annullal);
	f.remove(notext);
	f.remove(testo);    
	f.remove(salva);
	f.remove(apri);
	f.remove(annulla);         
	f.dispose();				}
      
    }
    public class annullaL implements ActionListener 
    {
      public void actionPerformed(ActionEvent e) {
	apri.removeActionListener(april);
	salva.removeActionListener(salval);
	annulla.removeActionListener(annullal);
	f.remove(notext);
	f.remove(testo);    
	f.remove(salva);
	f.remove(apri);
	f.remove(annulla);         	
	f.dispose();				}
      
    }
    
    
    
    
    Frame f=new Frame("Attenzione!");
    
    Button ok=new Button("S");
    Button no=new Button("No");
    
    Button apri=new Button("Apri con");
    Button salva=new Button("Salva su disco");
    Button annulla=new Button("Annulla");
    Label notext=new Label("File non testuale. Che ci faccio?");
    TextField testo=new TextField(15);
    Label nlab=new Label("UDP non ce la fa. Desideri riprovare con TCP?");
    okL okl=new okL();
    noL nol=new noL();
    apriL april=new apriL();
    salvaL salval=new salvaL();
    annullaL annullal=new annullaL();
    String received_message;
    URL u;
    public void actionPerformed(ActionEvent e) 
    {
      
      String toURL=urltext.getText();
      String temp1=urltext.getText();
      if (temp1.startsWith("http-tcp")&&udp.getState()) 
	{temp1=temp1.substring(8);
	temp1="http-udp"+temp1;
	urltext.setText(temp1);
	}
      if (temp1.startsWith("http-udp")&&tcp.getState()) 
	{temp1=temp1.substring(8);
	temp1="http-tcp"+temp1;
	urltext.setText(temp1);
	}
      
      
      int i=0;
      if (toURL.startsWith("http")||toURL.startsWith("HTTP")) {i=7;}
      if (toURL.startsWith("http-")||toURL.startsWith("HTTP-")) {i=11;}
      toURL=toURL.substring(i);
      System.out.println("analyze: "+toURL); 
      
      try 
	{
	  
	  
	  u=new URL("http://"+(toURL));
	  i=u.getPort();
	  if (i==-1) i=HTTP_STANDARD_PORT;
	  System.out.println("host="+u.getHost()+" port="+i+" prot="+u.getProtocol()+" anch="+u.getRef()+" file="+u.getFile());
	  String temp;
	  
	  //**controllo se era un reload
	  Button target = (Button)e.getSource();
	  if ((target.getLabel())!="Reload") 
	    received_message=incache(urltext.getText());
	  else received_message="";
	  if (received_message=="")
	    {
	      if (tcp.getState()) 
		{
		  temp=TcpClient2.Send(u.getHost(),u.getFile(),i,"get");
		  
		  actiontext.setText(temp.substring(temp.lastIndexOf("\r\n\r\n")+4));
		  
		}//if tcp
	      else 
  		{
		  UdpClient udpc =new UdpClient(1,u.getHost(),u.getFile(),u.getPort(),"GET");
		  udpc.run();
		  temp=udpc.message;
		  
		  actiontext.setText(temp.substring(udpc.message.lastIndexOf("\r\n\r\n")+4));
		}//else tcp
	      
	      System.out.println("temp msg=<<<"+temp+">>>");
	      received_message=temp.substring(temp.lastIndexOf("\r\n\r\n")+4);
	      
	      
	      System.out.println("\nLOOK cache_cur="+cache_cur+"\ncache_first="+cache_first+" cache_last="+cache_last);
	      
	      
	      
	      if (temp.startsWith("HTTP-UDP/1.0 444")) 
		{
		  
		  f.setLayout(new FlowLayout());
		  
		  ok.addActionListener(okl);
		  no.addActionListener(nol);
		  f.add(nlab);
		  
		  f.add(ok);
		  f.add(no);
		  f.setSize(450,100);
		  f.setLocation(320,160);
		  ok.setLocation(360,70);
		  no.setLocation(300,70);
		  ok.setSize(40,40);
		  no.setSize(40,40);
		  f.setBackground(Color.red);
		  f.setVisible(true);
		  f.requestFocus();
		  f.addWindowListener(
		    new WindowAdapter() {
		    public void windowClosing(WindowEvent e){
		      System.out.println("Window Closing");
		      ok.removeActionListener(okl);
		      no.removeActionListener(nol);
		      f.remove(ok);f.remove(no);f.remove(nlab);
		      f.dispose();
		    }
		  });
		  
		  
		}// if 444
	      
	      System.out.println("\nLOOK cache_cur="+cache_cur+"\ncache_first="+cache_first+" cache_last="+cache_last);
	      
	      
	      int k=temp.indexOf("Content-type:");
	      String cty=temp.substring(k+13);
	      cty=cty.trim();
	      cty=cty.toLowerCase();
	      System.out.println("cty="+cty);
	      if (cty.startsWith("text/plain")) 
		{System.out.println("testo puro!");
		
		/*****************
		  scrittura nella cache
		  **********************/
	  Integer I=new Integer(cache_last);
	  System.out.println("\ncache_cur="+cache_cur+"\ncache_first="+cache_first+" cache_last="+cache_last);
	  System.out.println("recvd msg=<<<"+received_message+">>>");
	  saveOnFile(received_message,WORKING_DIRECTORY+CACHE_DIRECTORY, I.toString());
	  saveOnFile(urltext.getText(),WORKING_DIRECTORY+CACHE_DIRECTORY, I.toString()+URL_EXTENSION);
	  cache_last=(cache_last+1)%CACHE_SIZE;
	  if (cache_first==cache_last) cache_first=(cache_first+1)%CACHE_SIZE;
		}
	    else 
	      {
		System.out.println("comp="+cty.compareTo("text/plain"));
		
		f.setLayout(new FlowLayout());
		
		salva.addActionListener(salval);
		apri.addActionListener(april);
		annulla.addActionListener(annullal);
		
		f.add(notext);
		f.add(testo);    
		f.add(salva);
		f.add(apri);
		f.add(annulla);
		
		f.setSize(450,100);
		f.setLocation(320,160);
		f.setBackground(Color.lightGray);
		f.setVisible(true);
		f.requestFocus();
		f.addWindowListener(
				    new WindowAdapter() {
		  public void windowClosing(WindowEvent e){
		    System.out.println("Window Closing");
		    apri.removeActionListener(april);
	salva.removeActionListener(salval);
	annulla.removeActionListener(annullal);
	f.remove(notext);
	f.remove(testo);    
	f.remove(salva);
	f.remove(apri);
	f.remove(annulla);         
	f.dispose();
		  }
		});
		
		
	      }//fine else di textplain
	  
	  
	  
	  
	  
	  //was here
	  
	    }//recv="" se non sta in cache
	else {
	  if (!(actiontext.getText()).endsWith("FROM CACHE")) actiontext.setText(actiontext.getText()+"\n FROM CACHE");
	  apri.removeActionListener(april);
	  salva.removeActionListener(salval);
	annulla.removeActionListener(annullal);
	f.remove(notext);
	f.remove(testo);    
	f.remove(salva);
	f.remove(apri);
	f.remove(annulla);
	}//else         
	}//fine try
  
  
	catch(Exception exc) 
	  { System.out.println(exc);
	  actiontext.setText("errore nella risorsa");
	  }//fine catch

    }//actionperformed
    }//fine sendbutlistener
  
  
  

  
  public class closebutL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      close_client();
      dispose();
      System.exit(0);
    }
  }
  

  public static void main(String[] args) {
    ClientGUI2 a = new ClientGUI2(args);
    a.setTitle("                                     GFG 1.0");
    
    a.addWindowListener(
      new WindowAdapter() {
      public void windowClosing(WindowEvent e){
	System.out.println("Window Closing");
	//close_client();
	System.exit(0);
      }
    }); 
    a.adjust();
    
    
    
  }
  } 






