
import java.awt.event.*;
import java.util.*;
import java.awt.*;
import java.net.*;
import java.io.*;
public class ClientGUI extends Frame {
 int ROWS=15,COLS=65;
 int X=500,Y=500;
static final int BUT_SIZE= 50;
static final int UP_BORDER= 50;
static final int DOWN_BORDER= 60;
static final int LEFT_BORDER= 20;
static final int GAP=20;
static final int HTTP_STANDARD_PORT =8080;	
static final String CACHE_DIRECTORY="cache";
static final String WORKING_DIRECTORY=".";
static final String CFG_FILE="gfg.cfg";
static final int BYTES_PER_ROW=40;
static final int CACHE_SIZE=2;

byte[] buf=new byte[BYTES_PER_ROW];
int cache_cur;
int cache_last;
  TextArea bigtext=new TextArea(ROWS,COLS);



  Button backbut=new Button("Back"),
  fwdbut = new Button("Forward"),
  reloadbut=new Button("Reload"),
  sendbut=new Button("Send"),
  closebut=new Button("Close"),

listbut=new Button("List");


CheckboxGroup cbg = new CheckboxGroup();
Checkbox tcp = new Checkbox("TCP", cbg, true);
Checkbox udp = new Checkbox("UDP", cbg, false);

 Label urllab=new Label("Location");

TextArea actiontext=new TextArea(ROWS,COLS);

TextField urltext=new TextField(COLS-10);

public int close_client()
{
   try {  //salva dati
               File f= (new File(WORKING_DIRECTORY,CFG_FILE));
             if (f.exists()) {  System.out.println("\n Already present.Overwrite!"); }
           //    System.out.println("new_ab: file exists "+f.exists()+" name "+f.getName());  //messaggio 
               FileOutputStream fos=new FileOutputStream(f);
               buf=(fill(cache_cur+"\r\n")).getBytes();
               fos.write(buf,0,BYTES_PER_ROW);
	       buf=(fill(cache_last+"\r\n")).getBytes();
               fos.write(buf,0,BYTES_PER_ROW);

               fos.close();
        System.out.println("new_ab: file exists "+f.exists()+" name "+f.getName());  //messaggio 
       
               return 0; 
             }catch(Exception ek){System.out.println("ecc "+ek);return 1;}
             

}

String fill(String s)
{
int temp=s.length();
if (temp>BYTES_PER_ROW) return s.substring(0,BYTES_PER_ROW);//sdfsdf
if (temp==BYTES_PER_ROW) return s;
temp=BYTES_PER_ROW-temp; //>0
String res=s;
for (int i=0;i<temp;i++) res+=" ";
  System.out.println("fill: res='"+res+"' lg="+res.length());
return  res;
}

int saveOnFile(String tosave,String name)
{
 try {  
               File file= (new File(".",name));
               byte[] buf=new byte[tosave.length()];
               System.out.println("creacc: file exists "+file.exists()+" name "+file.getName());  //messaggio 
               FileOutputStream fos=new FileOutputStream(file);
               buf=(name).getBytes();
               fos.write(buf);
               fos.close();
                
             }catch(Exception eee){System.out.println("errore sul file"); return -1;}
             	
return 0;
}

 
 ClientGUI(String args[]) {

/*******************************
lettura dei parametri di configurazione
********************************/

      

          try{  
                //operazioni sincronizzate
              
               File cf=new File(".",CFG_FILE);
               FileInputStream fis = new FileInputStream(cf);
               int lg=fis.read(buf);
               System.out.println("\n read "+lg+" bytes: "+buf+"\n");
               System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
 //System.out.println(" read "+lg+" bytes: "+buf+" ct="+counter+" buflg="+buf.length);             
               String temp=(new String(buf,0,lg));
//temp=fill(temp);
     System.out.println("temp= <"+temp+">");  
 
  Integer l=new Integer(temp.trim());
               System.out.println("\n letto = "+l+"\n");
               cache_cur=l.intValue();

    lg=fis.read(buf);
               System.out.println("\n read "+lg+" bytes: "+buf+"\n");
               System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
 //System.out.println(" read "+lg+" bytes: "+buf+" ct="+counter+" buflg="+buf.length);             
    		 temp=(new String(buf,0,lg));
               fis.close();
              l=new Integer(temp.trim());
               System.out.println("\n letto = "+l+"\n");
               cache_last=l.intValue();   
             
              
             }
catch(Exception ec)
{
	System.out.println(ec); 
	cache_cur=0;cache_last=0;}








  setLayout(new FlowLayout());

//tcp.addItemListener(new tcpL());
//udp.addItemListener(new udpL());
//savebut.addActionListener(new savebutL());
//loadbut.addActionListener(new loadbutL());

    backbut.addActionListener(new backbutL());
    fwdbut.addActionListener(new fwdbutL());
    reloadbut.addActionListener(new reloadbutL());
    closebut.addActionListener(new closebutL());
sendbut.addActionListener(new sendbutL());
listbut.addActionListener(new listbutL());
    add(backbut);
    add(fwdbut);
    add(reloadbut);
add(urllab);
add(closebut);
add(listbut);
add(sendbut);
    add(actiontext);
add(urltext);
    setForeground(Color.black);
// setLayout(new GridLayout(2, 1));

add(udp);
      add(tcp);
  }


 



public void adjust()
{
  
  setSize(X,Y);
  setResizable(false);
  setBackground(Color.lightGray);
  setVisible(true);

tcp.setLocation(X-4*GAP,UP_BORDER);
udp.setLocation(X-4*GAP,UP_BORDER+2*GAP);

 listbut.setLocation(LEFT_BORDER+3*BUT_SIZE+3*GAP,UP_BORDER);
  listbut.setSize(BUT_SIZE,BUT_SIZE);
  backbut.setLocation(LEFT_BORDER,UP_BORDER);
  backbut.setSize(BUT_SIZE,BUT_SIZE);
  fwdbut.setLocation(LEFT_BORDER+BUT_SIZE+GAP,UP_BORDER);
   fwdbut.setSize(BUT_SIZE,BUT_SIZE);
  reloadbut.setLocation(2*BUT_SIZE+2*GAP+LEFT_BORDER,UP_BORDER);
   reloadbut.setSize(BUT_SIZE,BUT_SIZE);
  closebut.setLocation(X/3*2, Y-DOWN_BORDER);
   closebut.setSize(BUT_SIZE,BUT_SIZE);
  sendbut.setSize(BUT_SIZE,BUT_SIZE);
sendbut.setLocation(X/3,Y- DOWN_BORDER);
  actiontext.setLocation(LEFT_BORDER,Y/3);
urltext.setLocation(LEFT_BORDER+3*GAP,Y/3-2*GAP); 

urllab.setLocation(LEFT_BORDER,Y/3-2*GAP);
}

//public class tcpL implements ItemListener {
 //public void actionPerformed(ItemEvent e) {
//String temp=urltext.getText();
//if (temp.startsWith("http-udp")) 
//	{temp=temp.substring(8);
//	temp="http-tcp"+temp;
//	urltext.setText(temp);

//	}    


//}
 // }
//public class udpL implements ItemListener {
// public void actionPerformed(ItemEvent e) {
//String temp=urltext.getText();
//if (temp.startsWith("http-tcp")) 
//	{temp=temp.substring(8);
//	temp="http-udp"+temp;
//	urltext.setText(temp);
  //  }
//  }
//}
 
 public class listbutL implements ActionListener {
 public void actionPerformed(ActionEvent e) {

Frame fdt = new FileDialogTest();
    fdt.resize(250,110);
    fdt.show();
    }
  }
 

  public class backbutL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
    }
  }

public class sendbutL implements ActionListener 
{


public class okL implements ActionListener 
{
    public void actionPerformed(ActionEvent e) {
int i;
	 i=u.getPort();
 	 if (i==-1) i=HTTP_STANDARD_PORT;
String temp="";
try {
 temp=TcpClient2.Send(u.getHost(),u.getFile(),i,"get");
}
catch (Exception ee) {System.out.println(ee);
	  actiontext.setText("errore nella risorsa");}
	
 actiontext.setText(temp.substring(temp.lastIndexOf("\r\n\r\n")/*+4*/));


f.dispose();
						}

}
public class noL implements ActionListener 
{
    public void actionPerformed(ActionEvent e) {
		
f.dispose();				}

}
public class salvaL implements ActionListener 
{
    public void actionPerformed(ActionEvent e) {

  try {  
               File file= (new File(".",testo.getText()));
               byte[] buf=new byte[received_message.length()];
               System.out.println("creacc: file exists "+file.exists()+" name "+file.getName());  //messaggio 
               FileOutputStream fos=new FileOutputStream(file);
               buf=(received_message).getBytes();
               fos.write(buf);
               fos.close();
                
             }catch(Exception eee){actiontext.setText("errore sul file");}
             

		
f.dispose();				}

}
public class apriL implements ActionListener 
{
    public void actionPerformed(ActionEvent e) {
FileDialog fd=new FileDialog(f);
String choice=fd.getFile();
		
f.dispose();				}

}
public class annullaL implements ActionListener 
{
    public void actionPerformed(ActionEvent e) {
		
f.dispose();				}

}




	Frame f=new Frame("Attenzione!");

	Button ok=new Button("S");
	Button no=new Button("No");
	
	Button apri=new Button("Apri con");
	Button salva=new Button("Salva su disco");
	Button annulla=new Button("Annulla");
Label notext=new Label("File non testuale. Che ci faccio?");
TextField testo=new TextField(15);
	Label nlab=new Label("UDP non ce la fa. Desideri riprovare con TCP?");
	okL okl=new okL();
	noL nol=new noL();
	apriL april=new apriL();
salvaL salval=new salvaL();
annullaL annullal=new annullaL();
String received_message;
URL u;
    public void actionPerformed(ActionEvent e) 
	{

	String toURL=urltext.getText();
	String temp1=urltext.getText();
	if (temp1.startsWith("http-tcp")&&udp.getState()) 
	{temp1=temp1.substring(8);
	temp1="http-udp"+temp1;
	urltext.setText(temp1);
	}
	if (temp1.startsWith("http-udp")&&tcp.getState()) 
	{temp1=temp1.substring(8);
	temp1="http-tcp"+temp1;
	urltext.setText(temp1);
	}

	
	int i=0;
	if (toURL.startsWith("http")||toURL.startsWith("HTTP")) {i=7;}
	if (toURL.startsWith("http-")||toURL.startsWith("HTTP-")) {i=11;}
	toURL=toURL.substring(i);
	System.out.println("analyze: "+toURL); 

 	try 
	{


	 u=new URL("http://"+(toURL));
	 i=u.getPort();
 	 if (i==-1) i=HTTP_STANDARD_PORT;
	 System.out.println("host="+u.getHost()+" port="+i+" prot="+u.getProtocol()+" anch="+u.getRef()+" file="+u.getFile());
	String temp;
	 if (tcp.getState()) 
	 {
	 temp=TcpClient2.Send(u.getHost(),u.getFile(),i,"get");

	 actiontext.setText(temp.substring(temp.lastIndexOf("\r\n\r\n")+4));

	  }
	 else 
  		{
		UdpClient udpc =new UdpClient(1,u.getHost(),u.getFile(),u.getPort(),"GET");
		udpc.run();
		temp=udpc.message;

		actiontext.setText(temp.substring(udpc.message.lastIndexOf("\r\n\r\n")+4));
		}

received_message=temp.substring(temp.lastIndexOf("\r\n\r\n"));

/*****************
scrittura nella cache
**********************/
saveOnFile(received_message,WORKING_DIRECTORY+File.pathSeparator+CACHE_DIRECTORY+cache_cur);


int k=temp.indexOf("Content-type:");
String cty=temp.substring(k+13);
cty.trim();
cty.toLowerCase();
if (cty.startsWith("text/plain")) {}
else 
{


f.setLayout(new FlowLayout());

salva.addActionListener(salval);
apri.addActionListener(april);
annulla.addActionListener(annullal);

f.add(notext);
f.add(testo);    
f.add(salva);
f.add(apri);
f.add(annulla);

f.setSize(450,100);
f.setLocation(320,160);
//ok.setLocation(360,70);
//no.setLocation(300,70);

//no.setSize(40,40);
f.setBackground(Color.lightGray);
f.setVisible(true);
f.requestFocus();
   f.addWindowListener(
      new WindowAdapter() {
        public void windowClosing(WindowEvent e){
          System.out.println("Window Closing");
apri.removeActionListener(april);
salva.removeActionListener(salval);
annulla.removeActionListener(annullal);
          f.dispose();
        }
      });
 

}//fine else di textplain







if (temp.startsWith("HTTP-UDP/1.0 444")) 
{

f.setLayout(new FlowLayout());

ok.addActionListener(okl);
no.addActionListener(nol);
f.add(nlab);
    
f.add(ok);
f.add(no);
f.setSize(450,100);
f.setLocation(320,160);
ok.setLocation(360,70);
no.setLocation(300,70);
ok.setSize(40,40);
no.setSize(40,40);
f.setBackground(Color.red);
f.setVisible(true);
f.requestFocus();
   f.addWindowListener(
      new WindowAdapter() {
        public void windowClosing(WindowEvent e){
          System.out.println("Window Closing");
ok.removeActionListener(okl);
no.removeActionListener(nol);
          f.dispose();
        }
      });
 
    
}

	}//fine try


	catch(Exception exc) 
	{ System.out.println(exc);
	  actiontext.setText("errore nella risorsa");
	}//fine catch

       }//actionperformed
  }//fine sendbutlistener




public class fwdbutL implements ActionListener {
 Frame f=new Frame("New address");

TextField intext1=new TextField(10);
TextField intext2=new TextField(10);
TextField intext3=new TextField(10);
Button ok=new Button("Done");
 Label nlab=new Label("Name");
  Label elab=new Label("E-mail");
  Label olab=new  Label("Other");
 okL okl=new okL();

    public void actionPerformed(ActionEvent e) {
f.setLayout(new FlowLayout());

ok.addActionListener(okl);
f.add(nlab);
f.add(intext1);
 f.add(elab);
f.add(intext2);
f.add(olab);
f.add(intext3);
  
   
    
f.add(ok);
f.setSize(100,300);
f.setLocation(320,0);
ok.setLocation(360,70);
f.setBackground(Color.red);
f.setVisible(true);
f.requestFocus();
   f.addWindowListener(
      new WindowAdapter() {
        public void windowClosing(WindowEvent e){
          System.out.println("Window Closing");
ok.removeActionListener(okl);
          f.dispose();
        }
      });
 
     actiontext.setText(actiontext.getText()+"\n"+"new address added");
    }
public class okL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
//System.out.println("new addr "+e.getActionCommand());
//if (e.getActionCommand()=="Done")
//{
//tempaddress.name(intext1.getText());
//tempaddress.email(intext2.getText());
//tempaddress.other(intext3.getText());
//int res=ab.add_item(username,actual_ab,tempaddress);
//if (res==0) actiontext.setText(actiontext.getText()+"\n insertion of address successful"); 
//else actiontext.setText(actiontext.getText()+"\n insertion of address NOT successful"); 
//ok.removeActionListener(okl);
//f.dispose();

//}
}

}



}
 

  public class reloadbutL implements ActionListener {
  Frame f=new Frame("Remove address");

TextField intext1=new TextField(10);
Button ok=new Button("Done");
okL okl=new okL(); 
    public void actionPerformed(ActionEvent e) {
f.setLayout(new FlowLayout());

ok.addActionListener(okl);

f.add(intext1);
f.add(ok);
f.setSize(100,200);
f.setLocation(320,0);
ok.setLocation(360,70);
f.setBackground(Color.red);
f.setVisible(true);
f.requestFocus();
   f.addWindowListener(
      new WindowAdapter() {
        public void windowClosing(WindowEvent e){
          System.out.println("Window Closing");
ok.removeActionListener(okl);
          f.dispose();
        }
      });


actiontext.setText(actiontext.getText()+"\n"+"removing address");
    }

public class okL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
System.out.println("new addr "+e.getActionCommand());
if (e.getActionCommand()=="Done")
{
//String search;
//{actiontext.setText(actiontext.getText()+"\n deletion "); search=intext1.getText();}

//int res=ab.remove_item(username,actual_ab,search);
//if (res==0) actiontext.setText(actiontext.getText()+"\n deletion of address successful"); 
//else if (res==5) actiontext.setText(actiontext.getText()+"\n"+" Permission denied"); 
//else actiontext.setText(actiontext.getText()+"\n deletion of address NOT successful"); 
//ok.removeActionListener(okl);
//f.dispose();
}
}

}


  }
 public class closebutL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
//   int res=ab.delete_ab(username,abtext.getText());
//if (res==0) actiontext.setText(actiontext.getText()+"\n"+" destruction of address book "+abtext.getText()+ " successful"); 
//else if(res==5) actiontext.setText(actiontext.getText()+"\n"+" permission denied"); 
//else actiontext.setText(actiontext.getText()+"\n"+" destruction of address book "+abtext.getText()+ " NOT successful"); 
close_client();
dispose();
System.exit(0);
    }
  }

//  public void whoareyou() 
//{
// final Frame ff=new Frame("Registering");

//final TextField intext1=new TextField(10);
//Button ok=new Button("It's me");
//ff.setLayout(new FlowLayout());

//ok.addActionListener(new ActionListener() {
  //  public void actionPerformed(ActionEvent e) {
//System.out.println("user name "+e.getActionCommand());

//username=intext1.getText();actiontext.setText(actiontext.getText()+"\n registered "+username); 

//ff.dispose();

//}

//});

//ff.add(intext1);
//ff.add(ok);
//ff.setSize(100,200);
//ff.setLocation(320,0);
//ok.setLocation(360,70);
//ff.setBackground(Color.blue);
//ff.setVisible(true);
//ff.requestFocus();
 //  ff.addWindowListener(
   //   new WindowAdapter() {
     //   public void windowClosing(WindowEvent e){
       //   System.out.println("Window Closing");
         // ff.dispose();
    //    }
    //  });
 
     //actiontext.setText(actiontext.getText()+"\n"+"user name");
    

//}

  public static void main(String[] args) {
    ClientGUI a = new ClientGUI(args);
    a.setTitle("                                     GFG 1.0");

    a.addWindowListener(
      new WindowAdapter() {
        public void windowClosing(WindowEvent e){
          System.out.println("Window Closing");
	//close_client();
          System.exit(0);
        }
      }); 
    a.adjust();



  }
} 

