
/*************************************************************************************************
Gestisce SOLAMENTE a livello di indici un buffer di lunghezza costante CIRCOLARE su cui  definito
un elemento pi vecchio, un elemento pi recente e un elemento corrente.
Si pu aggiungere un elemento (che diviene il pi recente e che pu sovrascrivere il pi vecchio)
si pu andare avanti fino al pi nuovo
si pu andare indietro fino al pi vecchio
***********************************************************************************************/


public class BufferCircolare
{
	int f,l,cur; //l punta il prossimo da scrivere
	int size;
	public static boolean verbose=false;
/** s  la dimensione del buffer*/
	BufferCircolare(int s) {size=s;f=0; l=0;cur=0;}
/** specifica primo, ultimo elemento e dimansione del buffer*/
	BufferCircolare(int fi,int la,int s) {f=fi; l=la; size=s;cur=fi;}

    public int getFirst() {return f;}
    public int getLast() {return l;}
   public int getCur() {return cur;}

public	void avanti() 
	{
		if (verbose) System.out.print(" Avanti ");
		if (l==f) return;
		if ((f<l)&&(f<=cur)&&(cur<l)&&(cur+1<l)) {cur++; return;}
		if ((l<f)&&(cur>=f)) {if ((cur+1)%size!=l) cur=(cur+1)%size; return;}
		if ((l<f)&&(cur<l)&&(cur+1<l))  {cur++; return;}
		
		
		return;
	}

public	void indietro() 
	{
		if (verbose) System.out.print(" Indietro ");
		if (l==f) return;
		int i=(cur-1)%size;
		
		if ((f<l)&&(f<=cur)&&(cur<l)) 
		    {
			if (f==cur) return;
			cur--; return;
		    }
		if ((l<f)&&(cur>=f)) {if (f==cur) return; cur--; return;} 
		if ((l<f)&&(cur<l)) {if (cur==0) cur=size-1; else cur--; return;}
		return;
		
	}

public	void scrivi()
	{
		if (verbose) System.out.print(" Scrivi ");
		l=(l+1)%size;
		if (l==f) f=(f+1)%size;
		if ((l>=f)&&cur>=l&&cur<f) {cur=f; return;}
		if ((l<f)&&cur<f&&cur>=l)  {cur=f; return;}
	
	}

public	void stampa()
	{if (verbose) System.out.println("f="+f+" l="+l+" c="+cur);}
	
public static void main(String args[])
	{
		BufferCircolare bc=new BufferCircolare(0,0,4);
		bc.avanti();
		bc.stampa();
		bc.indietro();
		bc.stampa();
		bc.scrivi();
		bc.stampa();
		bc.scrivi();
		bc.stampa();
bc.avanti();
		bc.stampa();bc.avanti();
		bc.stampa();bc.avanti();
		bc.stampa();bc.avanti();
		bc.stampa();
		bc.indietro();bc.stampa();
		bc.indietro();bc.stampa();
		bc.avanti();bc.stampa();
		bc.indietro();bc.stampa();
		bc.indietro();bc.stampa();
		bc.avanti();
		bc.stampa();
		bc.scrivi();
		bc.stampa();
		bc.scrivi();
		bc.stampa();
		bc.scrivi();
		bc.stampa();
		bc.scrivi();
		bc.stampa();
bc.indietro();bc.stampa();
		bc.indietro();bc.stampa();
		bc.indietro();bc.stampa();
bc.avanti();
		bc.stampa();bc.avanti();
		bc.stampa();bc.avanti();
		bc.stampa();bc.avanti();
		bc.stampa();
			
	
	}
}//fine class BufCirc
