import java.awt.event.*;
import java.util.*;
import java.awt.*;
import java.net.*;
import java.io.*;
public class ClientGUI2 extends Frame {
    int ROWS=20,COLS=60;
    int X=600,Y=600;
    static final int BUT_SIZE= 40;
    static final int UP_BORDER= 40;
    static final int DOWN_BORDER= 80;
    static final int LEFT_BORDER= 30;
    static final int GAP=25;
    static final int HTTP_STANDARD_PORT =8080;	
    static final String CACHE_DIRECTORY="cache";
    static final String WORKING_DIRECTORY="."+File.separator;
    static final String CFG_FILE="gfg.cfg";
    static final int BYTES_PER_ROW=4;
    static final int CACHE_SIZE=4;
    static final String URL_EXTENSION=".url";
  static final String TEMPFILE="tempfile.tmp";
 static final String SPECIAL_SYMBOL="$$";

    
    byte[] buf=new byte[BYTES_PER_ROW];

BufferCircolare bc; 
http_handler hh;    
int timeout;    
    
    
    Button backbut=new Button("Back"),
	fwdbut = new Button("Forward"),
	reloadbut=new Button("Reload"), //attenzione il nome  usato altrove
	sendbut=new Button("Send"),
	closebut=new Button("Close"),
	
	listbut=new Button("List");
    
    
    CheckboxGroup cbg = new CheckboxGroup();
    Checkbox tcp = new Checkbox("TCP", cbg, true);
    Checkbox udp = new Checkbox("UDP", cbg, false);
    
    Label urllab=new Label("Location");
    
    TextArea actiontext=new TextArea(ROWS,COLS);
    
    TextField urltext=new TextField(COLS-10);
    
    
    //**************MENU ZONE
    
    MenuBar mb1 = new MenuBar();
    Menu f = new Menu("File");
    
    MenuItem[] file = {
	
	new MenuItem("Open"),
	new MenuItem("Save"),
	
	new MenuItem("Exit", 
		     new MenuShortcut(KeyEvent.VK_E))
    };
    Menu o=new Menu("Options");
    MenuItem[] options={
	new MenuItem("Clear cache"),
new MenuItem("Set TimeOut")
    };
    
    // Initialization code:
    {
	ML ml=new ML();
	CCL ccl=new CCL();
	file[0].setActionCommand("Open");
	file[0].addActionListener(ml);
	file[1].setActionCommand("Save");
	file[1].addActionListener(ml);
	file[2].setActionCommand("Exit");
	file[2].addActionListener(ml);
	options[0].setActionCommand("ClearCache");
	options[0].addActionListener(ccl);
	options[1].setActionCommand("TimeOut");
	options[1].addActionListener(ccl);
	
    }
    class CCL implements ActionListener {
	public void actionPerformed(ActionEvent e) {
	    MenuItem target = (MenuItem)e.getSource();
	    String actionCommand = 
		target.getActionCommand();

	    if(actionCommand.equals("ClearCache")) {
		File ff;
		System.out.println("Clearing!!");
		for (int i=0;i<CACHE_SIZE;i++){
		    ff=new File(WORKING_DIRECTORY+CACHE_DIRECTORY,(new Integer(i)).toString());
		    ff.delete();
		    ff=new File(WORKING_DIRECTORY+CACHE_DIRECTORY,(new Integer(i)).toString()+URL_EXTENSION);
		    ff.delete();
		    
		}//for
		bc=new BufferCircolare(0,0,CACHE_SIZE);
	    }//if
    if(actionCommand.equals("TimeOut")) {
		
		timeout=askForTimeOut();
		    
	    }//if2
	}//performed
    }//CCL
    class ML implements ActionListener {
	public void actionPerformed(ActionEvent e) {
	    MenuItem target = (MenuItem)e.getSource();
	    String actionCommand = 
		target.getActionCommand();
	    if(actionCommand.equals("Open")) {
		FileDialog d = new FileDialog(
					      ClientGUI2.this,
					      "Apri file");
		d.setFile("*.*");
		d.setDirectory("."); // Current directory
		d.show();
		String yourFile = "*.*";
		if((yourFile = d.getFile()) != null) {
		    
		    
		    try {
			
			File cf=new File(d.getDirectory(),yourFile);
			FileInputStream fis = new FileInputStream(cf);
			byte[] tmpbuf=new byte[(new Long(cf.length())).intValue()];//***********************************************************************************
			
			int lg=fis.read(tmpbuf);
			System.out.println("\n read "+lg+" bytes: "+tmpbuf+"\n");
			System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
			String temp=(new String(tmpbuf,0,lg));
			
			System.out.println("temp= <"+temp+">");  
			
			actiontext.setText(temp);
			fis.close();
		    } catch (Exception er){actiontext.setText(er.toString());}
		    
		    
		    
		    
		    
		    
		    
		    
		} else {
		    actiontext.setText("You pressed cancel");
		    
		}
	    } //else
	    else if (actionCommand.equals("Save")) {
		FileDialog d = new FileDialog(
					      ClientGUI2.this,
					      "Salva file");
		d.setFile("*.*");
		d.setDirectory("."); // Current directory
		d.show();
		String yourFile = "*.*";
		if((yourFile = d.getFile()) != null) {
		    
		    saveBytesOnFile((actiontext.getText()).getBytes(),d.getDirectory(),yourFile);
		} else {
		    actiontext.setText("Operazione annullata");
		    
		}
	    }//else
	    
	    else if(actionCommand.equals("Exit")) {
		dispatchEvent(
			      new WindowEvent(ClientGUI2.this, 
					      WindowEvent.WINDOW_CLOSING));
	    }
	}
    }
    //************************
    
    
    
    
int askForTimeOut()
    {return 3000;}    
    
    public int close_client()
    {
	try {  //salva dati
	    File f= (new File(WORKING_DIRECTORY,CFG_FILE));
	    if (f.exists()) {  System.out.println("\n Already present.Overwrite!"); f.delete();}
	    //    System.out.println("new_ab: file exists "+f.exists()+" name "+f.getName());  //messaggio 
	    FileOutputStream fos=new FileOutputStream(f);
	    buf=(fill(bc.getFirst()+"\r\n")).getBytes();
	    fos.write(buf,0,BYTES_PER_ROW);
	    buf=(fill(bc.getLast()+"\r\n")).getBytes();
	    fos.write(buf,0,BYTES_PER_ROW);
	    
	    fos.close();
	    System.out.println("new_ab: file exists "+f.exists()+" name "+f.getName());  //messaggio 
	    
	    return 0; 
	}catch(Exception ek){System.out.println("ecc "+ek);return 1;}
	
	
    }
    
    String fill(String s)
    {
	int temp=s.length();
	if (temp>BYTES_PER_ROW) return s.substring(0,BYTES_PER_ROW);//sdfsdf
	if (temp==BYTES_PER_ROW) return s;
	temp=BYTES_PER_ROW-temp; //>0
	String res=s;
	for (int i=0;i<temp;i++) res+=" ";
	System.out.println("fill: res='"+res+"' lg="+res.length());
	return  res;
    }

    int saveOnFile(String tosave,String dir,String name)
    {
	System.out.println("tosave= <<<"+tosave+">>>");
	try {  
	    File file= (new File(dir,name));
	    byte[] buf=new byte[tosave.length()];
	    System.out.println("creacc: file exists "+file.exists()+" name "+file.getName());  //messaggio 
	    FileOutputStream fos=new FileOutputStream(file);
	    buf=(tosave).getBytes();
	    fos.write(buf);
	    fos.close();
	    
	}catch(Exception eee){System.out.println("errore sul file"); return -1;}
	
	return 0;
    }
    
    int saveBytesOnFile(byte tosave[],String dir,String name)
    {
	System.out.println("tosave= <<<"+tosave+">>>");
	try {  
	    File file= (new File(dir,name));
	 
	    System.out.println("saveBytes: file exists "+file.exists()+" name "+file.getName());  //messaggio 
	    FileOutputStream fos=new FileOutputStream(file);
	   
	    fos.write(tosave);
	    fos.close();
	    
	}catch(Exception eee){System.out.println("errore sul file"); return -1;}
	
	return 0;
    }
    
    String readFromFile(String dir,String filename)
    {
	
	try {

	    File cf=new File(dir,filename);
	    FileInputStream fis = new FileInputStream(cf);
	    byte[] tmpbuf=new byte[(new Long(cf.length())).intValue()];//***********************************************************************************
	    
	    int lg=fis.read(tmpbuf);
	    System.out.println("\n read "+lg+" bytes: "+tmpbuf+"\n");
	    System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
	    String temp=(new String(tmpbuf,0,lg));
	    
	    System.out.println("temp= <"+temp+">");  
	    fis.close();
	    return temp;
	} catch (Exception er){System.out.println(er); return "";}
    }
    
    byte [] readBytesFromFile(String dir,String filename)
    {
	
	try {
	    
	    File cf=new File(dir,filename);
	    FileInputStream fis = new FileInputStream(cf);
	    byte[] tmpbuf=new byte[(new Long(cf.length())).intValue()];//***********************************************************************************
	    
	    int lg=fis.read(tmpbuf);
	    System.out.println("\n read "+lg+" bytes: "+tmpbuf+"\n");
	    System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
	    String temp=(new String(tmpbuf,0,lg));
	    
	    System.out.println("temp= <"+temp+">");  
	    fis.close();
	    return tmpbuf;
	} catch (Exception er){System.out.println(er); return new byte[0];}
    }
    
    //*************COSTRUTTORE
    
    ClientGUI2(String args[]) {
	

http_handler hh=new http_handler();
	//******menu
	for(int i = 0; i < file.length; i++)
	    f.add(file[i]);
	for(int i = 0; i < options.length; i++)
	    o.add(options[i]);
	mb1.add(f);
	mb1.add(o);
	setMenuBar(mb1);
	
	//******menu ends





	/*******************************
					lettura dei parametri di configurazione
	********************************/
	
	
	try{  


	    File cf=new File(WORKING_DIRECTORY+"cache");
	    if (!cf.exists()) {cf.mkdirs();} 
	    
	    
	    cf=new File(WORKING_DIRECTORY,CFG_FILE);
	    FileInputStream fis = new FileInputStream(cf);
	    int lg=fis.read(buf);
	    System.out.println("\n read "+lg+" bytes: "+buf+"\n");
	    System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
	    //System.out.println(" read "+lg+" bytes: "+buf+" ct="+counter+" buflg="+buf.length);             
	    String temp=(new String(buf,0,lg));
	    //temp=fill(temp);
	    System.out.println("temp= <"+temp+">");  
	    
	    Integer l=new Integer(temp.trim());
	    System.out.println("\n cache_first = "+l+"\n");
	    int cachefirst=l.intValue();
	    
	
	    lg=fis.read(buf);
	    System.out.println("\n read "+lg+" bytes: "+buf+"\n");
	    System.out.println("constr: file exists "+cf.exists()+" name "+cf.getName());  
	    //System.out.println(" read "+lg+" bytes: "+buf+" ct="+counter+" buflg="+buf.length);             
	    temp=(new String(buf,0,lg));
	    fis.close();
	    l=new Integer(temp.trim());
	    System.out.println("\n cache_last = "+l+"\n");
	    int cachelast=l.intValue();   
	    bc=new BufferCircolare(cachefirst,cachelast,CACHE_SIZE);
bc.stampa();
	
	    
	}
	catch(Exception ec)
	    {
		System.out.println(ec); 
		 bc=new BufferCircolare(0,0,CACHE_SIZE);
bc.stampa();
		
	    }








	setLayout(new FlowLayout());
	
	backbut.addActionListener(new backbutL());
	fwdbut.addActionListener(new fwdbutL());
	reloadbut.addActionListener(new sendbutL());
	closebut.addActionListener(new closebutL());
	sendbut.addActionListener(new sendbutL());
	listbut.addActionListener(new listbutL());




	add(backbut);
	add(fwdbut);
	add(reloadbut);
    

	add(listbut);
	add(udp);
	add(tcp);
	add(urllab);
	add(urltext);
	
	add(actiontext);
	add(sendbut);
	add(closebut);  
	setForeground(Color.blue);

    }
    
    
public void execute(String s)
    {
 StringTokenizer st = new StringTokenizer(s);
int ct=st.countTokens()+1;
String[] str=new String[ct];
ct=0;
boolean put_file_name_at_the_end=true;
            while (st.hasMoreTokens()) {
String temp=st.nextToken();
if (temp.startsWith(SPECIAL_SYMBOL))
    {
	temp=TEMPFILE;
    put_file_name_at_the_end=false;

    }                
System.out.println(temp);
str[ct]=temp;
ct++;
            }

if (put_file_name_at_the_end) str[ct]=TEMPFILE;
Process run;
 try{
System.out.println("exec: "+str);
run=Runtime.getRuntime().exec(str);
 run.waitFor();}catch (Exception exc) {
System.out.println("exec error");
actiontext.setText("Le risorse di sistema non sono sufficienti per eseguire il programma. I dati sono nel file tempfile.tmp");
}

    }









    String incache(String url)
    {
	for (int i=0;i<CACHE_SIZE;i++){
	    String url2=readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,(new Integer(i)).toString()+URL_EXTENSION);
	    if (url.compareTo(url2)==0) return readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,(new Integer(i)).toString()+URL_EXTENSION);
	    
	    
	    
	}
	return "";
    }
    
    
    public void adjust()
    {
	
	setSize(X,Y);
	setResizable(false);
	setBackground(Color.lightGray);
	
	setVisible(true);

 	backbut.setLocation(LEFT_BORDER,UP_BORDER);
 	backbut.setSize(BUT_SIZE,BUT_SIZE);
 	fwdbut.setLocation(LEFT_BORDER+BUT_SIZE+GAP,UP_BORDER);
 	fwdbut.setSize(BUT_SIZE,BUT_SIZE);
 	reloadbut.setLocation(2*BUT_SIZE+2*GAP+LEFT_BORDER,UP_BORDER);
 	reloadbut.setSize(BUT_SIZE,BUT_SIZE);
 	listbut.setLocation(LEFT_BORDER+3*BUT_SIZE+3*GAP,UP_BORDER);
 	listbut.setSize(BUT_SIZE,BUT_SIZE);
 
 	actiontext.setLocation(LEFT_BORDER,Y/3);
 	urltext.setLocation(LEFT_BORDER+3*GAP,Y/3-2*GAP); 
 	closebut.setLocation(X/3*2, Y-DOWN_BORDER);
 	closebut.setSize(BUT_SIZE,BUT_SIZE);
 	sendbut.setSize(BUT_SIZE,BUT_SIZE);
 	sendbut.setLocation(X/3,Y- DOWN_BORDER);
 	urllab.setLocation(LEFT_BORDER,Y/3-2*GAP);
 	tcp.setLocation(2*X/3,UP_BORDER+GAP);
	udp.setLocation(2*X/3+60,UP_BORDER+GAP);
	    
	
    }
    
    
    public class listbutL implements ActionListener {
	public void actionPerformed(ActionEvent e) {
	    actiontext.setText("");
	    for (int i=0;i<CACHE_SIZE;i++){
		
		actiontext.setText(actiontext.getText()+"\n"+readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,(new Integer(i)).toString()+URL_EXTENSION));
		
	    }//for
	}//perform
    }//listener
    
    

    
    public class fwdbutL implements ActionListener 
    {
	
	public void actionPerformed(ActionEvent e) 
	{
	    bc.stampa();	
	    bc.avanti();
	    bc.stampa();
	    Integer I=new Integer(bc.getCur());
	    
	    
	    
	    actiontext.setText(readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,I.toString()));    
	    urltext.setText(readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,I.toString()+URL_EXTENSION));   
	}
		
    }
	
	
    
    
    
    public class backbutL implements ActionListener 
    {
	public void actionPerformed(ActionEvent e) 
	{
	    
	      bc.stampa();	
	    bc.indietro();
	    bc.stampa();
	    Integer I=new Integer(bc.getCur());
	    
	    actiontext.setText(readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,I.toString()));    
	    urltext.setText(readFromFile(WORKING_DIRECTORY+CACHE_DIRECTORY,I.toString()+URL_EXTENSION));   
	    
	}
	
	
    }
    
    public class sendbutL implements ActionListener 
    {
	
	
	public class okL implements ActionListener 
	{
	    public void actionPerformed(ActionEvent e)
	    {
		int i;
		i=u.getPort();
		if (i==-1) i=HTTP_STANDARD_PORT;
		String temp;
		try 
		    {
			TcpClient2 tc2=new TcpClient2();
			hh=
			    tc2.Send(u.getHost(),u.getFile(),i,"get",timeout);
			if (!hh.inbytes) temp=hh.msg;
			else 
			    {
				System.out.println("SONO QUI!! CASO NON TESTUALE IN RIPROVA CON TCP");
				
			    }
			//  ok.removeActionListener(okl);
//  			no.removeActionListener(nol);
//  			f.remove(ok);f.remove(no);f.remove(nlab);
//  			f.dispose();
		    }
		catch (Exception ee) 
		    {
			System.out.println("CGUI2 riga 536:"+ ee);
			actiontext.setText("errore nella risorsa");
		    }
		ok.removeActionListener(okl);
		no.removeActionListener(nol);
		f.remove(ok);f.remove(no);f.remove(nlab);
		f.dispose();
		
	    }
	    
		
	}
	public class noL implements ActionListener 
	{
	    public void actionPerformed(ActionEvent e) {
		ok.removeActionListener(okl);
		no.removeActionListener(nol);
		f.remove(ok);f.remove(no);f.remove(nlab);
		f.dispose();				}
	    
	}
	public class salvaL implements ActionListener 
	{
	    public void actionPerformed(ActionEvent e) {
		
		try { 
saveBytesOnFile(hh.bytes,".",testo.getText());
 
  
		    
		}catch(Exception eee){actiontext.setText("errore sul file");}
		
		
		apri.removeActionListener(april);
		salva.removeActionListener(salval);
		annulla.removeActionListener(annullal);
		f.remove(notext);
		f.remove(testo);    
		f.remove(salva);
		f.remove(apri);
		f.remove(annulla);         
		f.dispose();				}

	}
	public class apriL implements ActionListener 
	{
	    public void actionPerformed(ActionEvent e) {
		//FileDialog fd=new FileDialog(f);
		//String choice=fd.getFile();
try { 
saveBytesOnFile(hh.bytes,".",TEMPFILE);
 
  
		    
		}catch(Exception eee){actiontext.setText("errore sul file");}
		
execute(testo.getText());

		apri.removeActionListener(april);
		salva.removeActionListener(salval);
		annulla.removeActionListener(annullal);
		f.remove(notext);
		f.remove(testo);    
		f.remove(salva);
		f.remove(apri);
		f.remove(annulla);         
		f.dispose();				}
	    
	}
	public class annullaL implements ActionListener 
	{
	    public void actionPerformed(ActionEvent e) {
		apri.removeActionListener(april);
		salva.removeActionListener(salval);
		annulla.removeActionListener(annullal);
		f.remove(notext);
		f.remove(testo);    
		f.remove(salva);
		f.remove(apri);
		f.remove(annulla);         	
		f.dispose();				}
	    
	}
	
	
	
	
	Frame f=new Frame("Attenzione!");
	
	Button ok=new Button("S");
	Button no=new Button("No");
	
	Button apri=new Button("Apri con");
	Button salva=new Button("Salva su disco");
	Button annulla=new Button("Annulla");
	Label notext=new Label("File non testuale. Che ci faccio?");
	TextField testo=new TextField(15);
	Label nlab=new Label("UDP non ce la fa. Desideri riprovare con TCP?");
	okL okl=new okL();
	noL nol=new noL();
	apriL april=new apriL();
	salvaL salval=new salvaL();
	annullaL annullal=new annullaL();
       
	URL u;
	public void actionPerformed(ActionEvent e) 
	{

	    String toURL=urltext.getText();
	    String temp1=urltext.getText();
	    if (temp1.startsWith("http-tcp")&&udp.getState()) 
		{temp1=temp1.substring(8);
		temp1="http-udp"+temp1;
		urltext.setText(temp1);
		}
		if (temp1.startsWith("http-udp")&&tcp.getState()) 
		    {temp1=temp1.substring(8);
		    temp1="http-tcp"+temp1;
		    urltext.setText(temp1);
		    }
		
	
		int i=0;
		if (toURL.startsWith("http")||toURL.startsWith("HTTP")) {i=7;}
	if (toURL.startsWith("http-")||toURL.startsWith("HTTP-")) {i=11;}
	toURL=toURL.substring(i);
	System.out.println("analyze: "+toURL); 
	
 	try 
	    {
		
		
		u=new URL("http://"+(toURL));
		i=u.getPort();
		if (i==-1) i=HTTP_STANDARD_PORT;
		System.out.println("host="+u.getHost()+" port="+i+" prot="+u.getProtocol()+" anch="+u.getRef()+" file="+u.getFile());
		String temp;
		
		//**controllo se era un reload
		Button target = (Button)e.getSource();
//************************************HHHHHHHHHHHHHHHHHHHHH
 
 hh=new http_handler();
hh.msg="";
hh.msg=incache(urltext.getText());
//************************************HHHHHHHHHHHHHHHHHHHHH
 System.out.println("uqi");
		if (((target.getLabel())!="Reload")&&hh.msg!="") 
		    {
			
		     System.out.println("non e' reload, hh.msg non e' vuoto");   
			hh.inbytes=false;
			hh.more=false;
			hh.size=(hh.msg).length();
			hh.return_code="200";
			hh.authoritative=false;
			System.out.println(" search in cache... msg="+hh.msg);
		    }		
		else
		    //era reload oppure non stava in cache
		    {
			System.out.println("reload oppure non in cache msg=<"+hh.msg+">");
			if (tcp.getState()) 
			    {
				TcpClient2 tc2=new TcpClient2();
				hh=tc2.Send(u.getHost(),u.getFile(),i,"get",timeout);
				if (tc2.gotTimeOut){
				    hh=new http_handler(); hh.msg="TIMEOUT"; hh.inbytes=false;}
				else {
				if (!hh.inbytes) temp=hh.msg;
				else temp=new String(hh.bytes);
				}//timeout				
			    }//if tcp
			else 
			    {
				UdpClient udpc =new UdpClient(1,u.getHost(),u.getFile(),u.getPort(),"GET",timeout);
				udpc.run();       
				if (udpc.gotTimeOut)
				    {System.out.println("UDP TIMEOUT");
hh=new http_handler();				    
hh.msg="TimeOut!"; hh.inbytes=false;}
				else {
				    ByteArrayInputStream bais=
					new ByteArrayInputStream(udpc.bytes);
				    hh=new http_handler(bais,udpc.BUFFER_SIZE);
				    hh.read();
				    hh.authoritative=true;}
				System.out.println("udpc invocato...");
				
			    }//else tcp
			
			System.out.println("controllo 444");
			
			//***/*//*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
			if (udp.getState()&&((hh.return_code).startsWith("444"))) 
			    {
				
				f.setLayout(new FlowLayout());
				
				ok.addActionListener(okl);
				no.addActionListener(nol);
				f.add(nlab);
				
				f.add(ok);
				f.add(no);
				f.setSize(450,100);
				f.setLocation(320,160);
				ok.setLocation(360,70);
				no.setLocation(300,70);
				ok.setSize(40,40);
				no.setSize(40,40);
				f.setBackground(Color.red);
				f.setVisible(true);
				f.requestFocus();
				f.addWindowListener(
						    new WindowAdapter() {
				    public void windowClosing(WindowEvent e){
					System.out.println("Window Closing");
					ok.removeActionListener(okl);
					no.removeActionListener(nol);
					f.remove(ok);f.remove(no);f.remove(nlab);
					f.dispose();
				    }
				});
				
				
			    }// if 444
			
			System.out.println("\ndopo 444");
			
			
		
			if (!hh.inbytes) 
			    {System.out.println("testo puro!");
			    actiontext.setText(hh.msg);
			    /*****************
					      scrittura nella cache
			    **********************/
			    Integer I=new Integer(bc.getLast());
			
			    bc.stampa();
			    bc.scrivi();
			    bc.stampa();
			    
			    System.out.println("recvd msg=<<<"+hh.msg+">>>");
			    saveOnFile(hh.msg,WORKING_DIRECTORY+CACHE_DIRECTORY, I.toString());
			    saveOnFile(urltext.getText(),WORKING_DIRECTORY+CACHE_DIRECTORY, I.toString()+URL_EXTENSION);
			    
			    }
			else 
			    {
				System.out.println("finestra per file non testuali");
//f=new Frame("Attenzione!");
				System.out.println("OOO");
				f.setLayout(new FlowLayout());
				
				salva.addActionListener(salval);
				apri.addActionListener(april);
				annulla.addActionListener(annullal);
				
				f.add(notext);
				f.add(testo);    
				f.add(salva);
				f.add(apri);
				f.add(annulla);
			    
				f.setSize(450,100);
				f.setLocation(320,160);
				f.setBackground(Color.lightGray);
				f.setVisible(true);
				f.requestFocus();
				f.addWindowListener(
						    new WindowAdapter() {
				    public void windowClosing(WindowEvent e){
					System.out.println("Window Closing");
					apri.removeActionListener(april);
					salva.removeActionListener(salval);
					annulla.removeActionListener(annullal);
					f.remove(notext);
				    f.remove(testo);    
				    f.remove(salva);
				    f.remove(apri);
				    f.remove(annulla);         
				    f.dispose();
				}
				});
				
				
			    }//fine else di textplain
			
			
			
			
			
			//was here
			
		    }//recv="" se non sta in cache
		if (!hh.authoritative)  {
		    if (!(actiontext.getText()).endsWith("FROM CACHE")) actiontext.setText(actiontext.getText()+"\n FROM CACHE");
		    apri.removeActionListener(april);
		    salva.removeActionListener(salval);
		    annulla.removeActionListener(annullal);
		    f.remove(notext);
		    f.remove(testo);    
		    f.remove(salva);
		    f.remove(apri);
		    f.remove(annulla);
		}//else         
	    }//fine try
	
	catch(InterruptedIOException eee) { System.out.println(eee);
	actiontext.setText("TimeOut!!");
	}//fine catch
	catch(Exception exc) 
	    { System.out.println(exc);
	    actiontext.setText(actiontext.getText()+"errore nella risorsa");
	    }//fine catch
	
	}//actionperformed
    }//fine sendbutlistener





 public class closebutL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
close_client();
dispose();
System.exit(0);
    }
  }


  public static void main(String[] args) {
    ClientGUI2 a = new ClientGUI2(args);
    a.setTitle("                                            GFG 1.0");


//  byte b[]=a.readBytesFromFile(".","dragon.jpg");
//  a.saveBytesOnFile(b,".","d1.jpg");


    a.addWindowListener(
      new WindowAdapter() {
        public void windowClosing(WindowEvent e){
          System.out.println("Window Closing");
       
          System.exit(0);
        }
      }); 
    a.adjust();



  }
} 

