import java.net.*;
import java.io.*;
//import http_handler;
/*******************								     Questa classe si occupa della creazione del socket su cui transiteranno
										     i dati. Ha un valore di default per il buffer di ricezione, che pu venire
										     impostato, e che non utilizza esplicitamente. Questo perch TcpClient2
										     utilizza un gestore dello stream dati (httphandler) che ha la necessit
										     del buffer.
										     
********************************************************************/



public class TcpClient2 {
    
  public int RECEIVE_BUFFER=7000;//valore di default
  
   boolean gotTimeOut;
  Socket socket;
  public static boolean verbose=false;
  /* tenta la chiusura del socket*/
  public void shutdown()
    { try{socket.close(); if (verbose) System.out.println(" USER REQUEST:closing sock in TcpCl2...");}
    catch(IOException ioe) {if (verbose) System.out.println("Can't close!!!!!!");}}
  
  /* funzione principale: restituisce l'handler dello stream dati, 
     invia la richiesta costruendola con la funzione pacchetto_richiesta e
     attende per un tempo massimo settato in timeout la risposta*/
  public http_handler Send(String hostname,String resource,int port,String method,int timeout,int bufsize) 	throws IOException {
    gotTimeOut=false;
    String p,protocol="TCP";
    InetAddress addr = InetAddress.getByName(hostname);
	
    if (verbose) System.out.println("addr = " + addr);
    
    socket = 
      new Socket(addr, port);
    try {
      InetAddress localaddr = socket.getLocalAddress();
      
      if (verbose) System.out.println("socket = " + socket);
      socket.setSoTimeout(timeout);//setta il timeout
      InputStream in=socket.getInputStream();
      
      OutputStream out=socket.getOutputStream();
      p=http_handler.pacchetto_richiesta(resource,protocol,method,localaddr.getHostAddress());
	    
      out.write(p.getBytes());
      
      if (verbose) System.out.println("scritto!");
      if (bufsize>0)
	RECEIVE_BUFFER=bufsize;    
      http_handler      hh=new http_handler(in,RECEIVE_BUFFER);
      hh.read();

	    if (verbose) System.out.println("tcpCL2 auto shut..");
	    //if (!hh.more) shutdown();
	    /*else*/ hh.socket=socket;
	    hh.authoritative=true;//not from cache
	    
	    
	    if (verbose) System.out.println(" avail="+in.available());
	    
	    return hh;
	    
    } 
    catch(InterruptedIOException iioe) 
	{gotTimeOut=true; http_handler hh=new http_handler(); 
	hh.msg="TIMEOUT!";if (verbose) System.out.println(iioe); hh.inbytes=false;socket.close(); if (verbose) System.out.println(" closing sock in TcpCl2...");return hh;     }
    catch(IOException ee) 
	{http_handler hh=new http_handler(); 
	if (verbose) System.out.println(ee);
	System.out.println(ee);
	//printStackTrace();
	hh.msg="I/O ERROR"; hh.inbytes=false;socket.close();if (verbose) System.out.println(" closing sock in TcpCl2..."); return hh; 
	}
    //finally { //comunque chiudiamo il socket
    //if (verbose) System.out.println(" closing TcpCl2...");
    //socket.close();
	
   // }
	
  }
    
  public static void main(String args[])
    {
      
    } 
}

